﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApplication61.ViewModel;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication61
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Record newrecord;
        Record lastrec;
        VM vm = new VM();
        double extheight = 0;

        SolidColorBrush _hoverBrush = new SolidColorBrush(Colors.Red);
        SolidColorBrush _activeBrush = new SolidColorBrush(Colors.Yellow);
        SolidColorBrush _selectedBrush = new SolidColorBrush(Colors.ForestGreen);
        public MainWindow()
        {
            InitializeComponent();
            layoutroot.DataContext = vm;
        }

     

  

        private void AddNonPromptRules(FieldLayout fieldLayout)
        {
            string[] fieldList = { "Date", "PromptDate", "LmeOfficialSod_1A", "Lme3mSpread_2B", "LmeTimeSpread_2A", "LmeVisibleSpread_9X", "LmeContractSpread_9Y", "LmeEodTimeSpread_9A", "LmeEodVisibleSpread_9V", "LmeEodContractSpread_9W", "LmeEod3mSpread_9B", "LmeIntraday_1C", "FxForward_6A", "LmeFxSwapSpread_7A", "LmeIntradayFx_8A" };
            foreach (string fieldListName in fieldList)
            {
                var field = fieldLayout.Fields.FirstOrDefault(f => f.Name == fieldListName);
                if (field != null)
                {
                    var style = field.Settings.CellValuePresenterStyle;
                    if (style == null)
                        style = new Style();

                    // Gray background and white foreground if non-prompt
                    var dataTrigger = new DataTrigger();
                    dataTrigger.Binding = new Binding("DataItem.PromptDate")
                    {
                        Converter = new IsWeekendOrHolidayConverter(),
                        ConverterParameter = null
                    };
                    dataTrigger.Value = true;
                    //comment out line below and hoverbrush, activebrush, selected brush work
                     dataTrigger.Setters.Add(new Setter(CellValuePresenter.BackgroundProperty, new SolidColorBrush(Color.FromRgb(162, 159, 162))));
                    dataTrigger.Setters.Add(new Setter(CellValuePresenter.BorderThicknessProperty, new Thickness(0.0, 0.0, 0.0, 0.0)));
                    // Need to escalate to Infragistics why the Setter for BackgroundProperty (above) breaks BackgroundHoverProperty and BackgroundActiveProperty (below)
                    // Only BackgroundActive seems to still work despite the BackgroundProperty Setter
                    // Commenting-out BackgroundProperty restores functionality of other Background Setters
                    dataTrigger.Setters.Add(new Setter(CellValuePresenter.BackgroundHoverProperty, _hoverBrush));
                    dataTrigger.Setters.Add(new Setter(CellValuePresenter.BackgroundActiveProperty, _activeBrush));
                    dataTrigger.Setters.Add(new Setter(CellValuePresenter.BackgroundSelectedProperty, _selectedBrush));

                    if ((fieldListName != "Date") && (fieldListName != "PromptDate"))
                        dataTrigger.Setters.Add(new Setter(CellValuePresenter.ForegroundProperty, new SolidColorBrush(Colors.White)));

                    style.Triggers.Add(dataTrigger);
                    field.Settings.CellValuePresenterStyle = style;
                }
            }
        }

        private void xgrid1_Loaded(object sender, RoutedEventArgs e)
        {
            FieldLayout f = xgrid1.FieldLayouts[0];
            AddNonPromptRules(f);
        }

        private void openwindow_Click(object sender, RoutedEventArgs e)
        {
            Window1 w1 = new Window1();
            w1.Show();
        }

        private void openwindow1_Click(object sender, RoutedEventArgs e)
        {
            Window2 w2 = new Window2();
            w2.Show();
        }

        private void Openwindow2_Click(object sender, RoutedEventArgs e)
        {
            Window3 w3 = new Window3();
            w3.Show();
        }


      
 
    }
}
